#!/usr/bin/perl
#
#
#     Daily Pic
#     Free Version
#     By David Powell
#     Copyright 2000, Matrix Vault Productions
#     You are free to use this script for personal home pages and non-profit organizations only. You may not manipulate or 
#     distribute this script without expressed written permission from David Powell and Matrix Vault Productions. This script
#     comes with no guarantees or warranties of any kind.
#
#     This version is severly limited, and can only read images with numbered filenames.
#      For a full version that includes the ability to use non-numbered filenames, build templates,
#     and more, goto http://www.matrixvault.com/cgi for the latest PRO version.
#
##################################
# 
#   Installation
#
#
#  1. edit the variables and perl location in the script.
#  2. upload it to your cgi-bin and chmod it 755.
#  3. Make sure all images are in the image file directory defined below.
#  4. Make sure images are numbered in nonbreaking sequence: 1.gif, 2.gif, 3.gif, etc..
#  5. Call this script in an image tag in an HTML page:
#       <img src="http://www.yourdomain.com/your-cgi-bin/daily_pic.cgi">
###################################
#
#

# The UNIX dir the where the images are stored - no trailing slash
#$image_dir="/virtualhosts/matrixvault.com/www//cgi-local/daily_pic/images";

# The HTTP URL of the above, no trailing slash
$image_http_dir = "http://www.matrixvault.com/cgi-local/daily_pic/images";

# The number of images in the cycle
$image_max = "8";

# The time between each image increment in seconds: 86400 = 1 day
$cycle_time = "30";

# The extention of your image files - use no dot!
$ext = "jpg";

###################################
#
#
#
	$time= time;
#print "Content-type: text/html\n\n";

###########
#
#   Front Door
#

	&direct_insert;
	exit;


###########
# Read the time log and assign the image file name
###########
sub read_time_log
{
	if (-e "count.log") 
		{
		open (LOG, "count.log") || &error ("cannot open time log");
		$line = (<LOG>);
		close(LOG);
		($count,$log_time) = split(/\|/,$line);
		} else {$count =0;}
	
# now adjust the time and count if neccessary

	$time_diff = $time - $log_time;

	if ($time_diff >= $cycle_time)
		{
			open (LOG, ">count.log") || &error ("Cannot open Time.log for writing new time and count");
			$count++;
			if ($count > $image_max) {$count = "1";}
			print LOG "$count|$time";
			close(LOG);
		}
	$image_file="$image_http_dir\/$count.$ext";
}

############
# Direct Insert into a template and save to hard drive
############
sub direct_insert
{
	&read_time_log;
	print "Location: $image_file\n\n";
	exit;
}

############
# Error Handling
############
sub error
{
print "Content-type: text/html\n\n";
print "Daily Pic Error: $_[0]";
exit;
}
		


